﻿Type=Class
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	Private PropMap	As Map
	
End Sub

'Initializes the object 
'Create an internal map of all the keys/values found with 'getprop' command.
'This map is updated ONLY during library initialization.
Public Sub Initialize
	nativeMe = Me
	PropMap.Initialize
	
	'get full device info as map of key/value where the key is the parameter
	Dim S As String= nativeMe.RunMethod("DeviceFullInfo",Null)
	If S<> Null And S <>"" Then
	'\[.*?\]*\[.*?\]
		Dim Pt As String="\[.*?\]*\[.*?\]"
		Dim Mtc As Matcher
		Mtc=Regex.Matcher(Pt,S)
		Do While Mtc.Find
			Dim PropKey As String=Mtc.Match.SubString2(1,Mtc.Match.IndexOf("]:"))
			Dim PropVal As String=Mtc.Match.substring2(Mtc.Match.LastIndexOf("[")+1,Mtc.Match.Length-1)
			'Log ("Key value: " & PropKey & " " & PropVal)
			'Log ("Found: " & Mtc.Match)
			PropMap.Put(PropKey,PropVal)
		Loop
	Else
		Log("Error, full info are  not available")
	End If
		
End Sub

'Full query: getprop
'return all device properties strings as a map of property name (key) and property value (value).
'Please note that the properties values are readed during library initialization and could change during device usage.
'Use getPropertyValue to get the updated value of a given key.
Public Sub getAllProperties As Map
	Return PropMap
	
End Sub

'Return a string with the updated value of the given key, return an empty string if the key doesn't exist
'It is advided to use the KeyExist method before using this.
Public Sub getPropertyValue (PropertyKey As String) As String
	Dim S As String= nativeMe.RunMethod("DeviceInfo",Array As String(PropertyKey))
	If S<> Null And S <>"" Then
		Return S
	Else
		Return ""
	End If
	
End Sub

'Verify if a given key exist, return true if exist else return false
Sub KeyExist(Key As String) As Boolean
	For Each st As String In PropMap.Keys
		If st.Contains(Key) Then
			Return True
		End If
	Next
	Return False

End Sub

'Return a map of keys/values that contains the search key(word).
'The value is updated during the search, if a matching key is found.
'Return an empty map if no match.
Public Sub SearchForKey(SearchFor As String) As Map
	Dim FoundMap As Map
	FoundMap.Initialize
	
	For Each st As String In PropMap.Keys
		If st.Contains(SearchFor) Then
			FoundMap.Put(st,getPropertyValue(st))
		End If
	Next
	Return FoundMap
	
End Sub

#If JAVA

/*
example:
adb logcat | grep "SEARCH_TERM"
adb logcat | grep "SEARCH_TERM_1\|SEARCH_TERM_2"
adb logcat | grep "Exception"
adb logcat | grep "Exception\|Error"
*/

//import android.content.Context;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;


String line = "";
String groupline="";

public String DeviceInfo(String DeviceValue) {
	try {
		//getprop net.hostname
		line="";
	 	Process ifc = Runtime.getRuntime().exec("getprop "+ DeviceValue);
	 	BufferedReader bis = new BufferedReader(new InputStreamReader(ifc.getInputStream()));
	 	line = bis.readLine();
	 	ifc.destroy();
		 return line;
		} 
	catch (java.io.IOException e) {
	 	return "error" + e;
		}
	}
	
public String DeviceGroupInfo(String GroupValue) {
	try {
		//getprop | grep "product"
		line="";
		groupline="";
	 	Process ifc = Runtime.getRuntime().exec("getprop | grep " + GroupValue);
	 	BufferedReader bis = new BufferedReader(new InputStreamReader(ifc.getInputStream()));
	 	while ((line = bis.readLine()) != null) {
			groupline=groupline+line;
			}	
	 	ifc.destroy();
		return groupline;
		} 
	catch (java.io.IOException e) {
	 	return "error" + e ;
		}
	}
	
public String DeviceFullInfo() {
	try {
		//getprop
		line="";
		groupline="";
	 	Process ifc = Runtime.getRuntime().exec("getprop");
	 	BufferedReader bis = new BufferedReader(new InputStreamReader(ifc.getInputStream()));
	 	while ((line = bis.readLine()) != null) {
			groupline=groupline+line;
			}	
	 	ifc.destroy();
		return groupline;
		} 
	catch (java.io.IOException e) {
	 	return "error" + e ;
		}
	}

#End If